#include "Spark.h"
#include <cmath>
#include <ngl/ShaderManager.h>

Spark::Spark(
              ngl::Vector _pos,
              ngl::Vector _dir,
              ngl::Colour _c,
							const std::string &_shaderName,
							ngl::TransformStack *_transform

             ) :
                Particle(
                         _pos,
                         _dir,
                         _c,
												 _shaderName,
												 _transform
                        )
{
  m_lastPos=_pos;
	m_dir.normalize();
}


void Spark::draw()
{
  ngl::ShaderManager *shader=ngl::ShaderManager::instance();
  (*shader)[m_shaderName]->use();
	shader->setShaderParam4f(m_shaderName,"Colour",m_colour.m_r,m_colour.m_g,m_colour.m_b,m_colour.m_a);
	m_transform->pushTransform();
	{
		m_transform->setPosition(m_pos);
		std::vector<ngl::Vector> points;
		points.push_back(m_lastPos);
		points.push_back(m_pos);

		m_transform->loadGlobalAndCurrentMatrixToShader(m_shaderName,"ModelMatrix");
		glEnableClientState(GL_VERTEX_ARRAY);
		glVertexPointer(4, GL_FLOAT, 0, &points[0]);
		glDrawArraysInstancedARB(GL_LINES, 0, points.size(),1);
		glDisableClientState(GL_VERTEX_ARRAY);
	}
	m_transform->popTransform();
}


void Spark::update()
{
// more the particle by adding the Direction vector to the position
  m_lastPos=m_pos;
  m_pos+=m_dir;
	m_lastPos.m_w=1.0;
	m_pos.m_w=1.0;
  ++m_life;
  if(m_life > m_maxLife)
	{
    m_life=0;
    m_pos=0;
	}
}













